﻿using Infragistics.Controls.Grids;
using Infragistics.Olap;
using Infragistics.Olap.Data.Base;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Olap.FlatData;
using System.Windows.Threading;

namespace xamPivotGridCellEditing
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            var data = new SampleFlatData();
            grid.DataContext = data;
        }

        IEnumerable<PivotCell> cells;
        IEnumerable<PivotDataColumn> columns;
        IEnumerable<PivotDataRow> rows;

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            cells = this.pivotGrid.SelectionSettings.SelectedCells.ToList<PivotCell>();
            columns = this.pivotGrid.SelectionSettings.SelectedColumns.ToList<PivotDataColumn>();
            rows = this.pivotGrid.SelectionSettings.SelectedRows.ToList<PivotDataRow>();

            (((this.pivotGrid.DataSource as FlatDataSource).ItemsSource as ICollectionView).SourceCollection as ObservableCollection<Sale>)[0].NumberOfUnits += 10;
            (((this.pivotGrid.DataSource as FlatDataSource).ItemsSource as ICollectionView)).Refresh();
            (this.pivotGrid.DataSource as FlatDataSource).ResultChanged += DataSource_ResultChanged;
            (this.pivotGrid.DataSource as FlatDataSource).RefreshGrid();
            
        }
        
        private void DataSource_ResultChanged(object sender, ResultChangedEventArgs e)
        {
            foreach (var cell in cells)
            {
                var colKey = cell.Column.Index;
                var rowKey = cell.DataRow.HeaderText;
                var row = this.pivotGrid.GridLayout.Rows.Where(r => r.HeaderText == rowKey).FirstOrDefault();

                this.pivotGrid.SelectionSettings.SelectedCells.Add(row.Cells[colKey]);
            }

            foreach (var column in columns)
            {
                var colKey = column.Index;
                var col = this.pivotGrid.GridLayout.Columns.Where(c => c.Index == colKey).FirstOrDefault();

                this.pivotGrid.SelectionSettings.SelectedColumns.Add(col);
            }
            foreach (var row in rows)
            {
                var rowKey = row.HeaderText;
                var currentRow = this.pivotGrid.GridLayout.Rows.Where(r => r.HeaderText == rowKey).FirstOrDefault();

                this.pivotGrid.SelectionSettings.SelectedRows.Add(currentRow);
                
            }
        }
        
    }
}

